#!/bin/bash

# small bash script example
# how to process ditributed factoring
# written 2004-02 by Thorsten Reinecke

# if this script doesn't work as expected:
# please activate option "NOTIFY_PARENT" in the makefile and recompile!
# please also compile src/notify.cc and copy the binary to ./notify


function catch_SIGUSR1 ()
{
  # -> ready to consume clients
  echo "Signal SIGUSR1 catched"
  autostart_clients.sh
}

function catch_SIGUSR2 ()
{
  # -> factor found
  echo "Signal SIGUSR2 catched"
  echo -e \\a;
}

function catch_SIGINT ()
{
  echo "Signal SIGINT catched"
  echo "aborting script..."
  kill %+
  kill 0
}


# catch these signals
trap catch_SIGUSR1 SIGUSR1
trap catch_SIGUSR2 SIGUSR2
trap catch_SIGINT SIGINT

# enable bash job control
set -m


i=9000
STATUS=0
while [ $STATUS -eq 0 ]; do
 if [ $i -gt 10000 ]; then break; fi
 server P$i &
# qsieve P$i &
 wait %+
 STATUS=$?
 while [ $STATUS -gt 128 ]; do
  echo "received status $STATUS"
  wait %+
  STATUS=$?
 done
 echo "now status $STATUS"
 i=$((i+1))
done

echo "goodbye..."
